local paused = false
local skip_end = false
local extra_playtime = 0
local save_tmr = nil
local p_voices = {"Resume Game","Save Game","Load Game","Options","Return Main Menu"}
local p_voices_opt = {"Graphics Settings", "Audio Settings", "Return Back"}
local p_voices_graphics = graphics_voices
local p_voices_audio = audio_voices
p_voices_audio[3] = "Return Back"
p_voices_graphics[3] = "Return Back"
local marked_cells = {}
local cur_voices = p_voices
local scrolls = scrolls_num[idx_sizes]
local p_idx = 1
bgm = Sound.open("app0:/files/game.ogg")
spell = Sound.open("app0:/files/spell.ogg")
Sound.play(spell, NO_LOOP)
Sound.pause(spell)
PlayMusic(bgm, LOOP)
RayCast3D.noClipMode(noclip)
local a_st = 0
local tcells = {}
Graphics.termBlend()
Screen.flip()
if saved_playtime ~= nil then
	extra_playtime = saved_playtime
	scrolls = load_scrolls
	RayCast3D.spawnPlayer(load_x, load_y, load_angle)
	saved_playtime = nil
	for i, cell in pairs(load_marked_cells) do
		table.insert(marked_cells, cell)
	end
	load_tmr = Timer.new()
end
Timer.reset(tmr)
Timer.resume(tmr)

function DrawPause()
	i = 1
	Font.setPixelSizes(ttf,40)
	Font.print(ttf, 8, 15, "PAUSED GAME", cyan)
	Font.setPixelSizes(ttf,28)
	Font.print(ttf, 8, 500, "Seed: " .. seed, yellow)
	while i <= #cur_voices do
		if i == p_idx then
			color = yellow
			x = 20
		else
			color = white
			x = 15
		end
		if cur_voices == p_voices then
			if i == 3 and #save_slots == 0 then
				color = gray
			end
		end
		Font.print(ttf, x, 50 + 30 * i, cur_voices[i], color)
		i = i + 1
	end
end

Timer.reset(sec)
while true do
	
	-- Rendering scene
	Graphics.initBlend()
	if use_shading then
		Graphics.drawImage(0, 0, skybox)
	else
		Graphics.fillRect(0,960,0,544,ceil_c) -- Simulates skybox; currently faster then sky rendering
		Graphics.fillRect(0,960,273,544,floor_c) -- Simulates floor; currently faster then floor rendering
	end
	RayCast3D.renderScene(0,0)
		
		-- Player Animation
	Graphics.drawPartialImage(284,440,anim,0,104 * a_st,376,104)
	
	-- Drawing Framerate
	frame = frame + 1
	if Timer.getTime(sec) >= 1000 then
		fps = frame
		frame = 0
		Timer.reset(sec)
	end
	Font.print(ttf, 870, 500, math.floor(fps), yellow)
	
	-- Drawing Scrolls
	if mode ~= nil then
		Font.print(ttf, 700, 20, "Scrolls: " .. scrolls, yellow)
	end
	
	-- Drawing save advice
	if save_tmr ~= nil then
		if Timer.getTime(save_tmr) > 4000 then
			Timer.destroy(save_tmr)
			save_tmr = nil
		else
			Font.print(ttf, 8, 470, "Game saved successfully!", yellow)
		end
	end
	
	-- Drawing load advice
	if load_tmr ~= nil then
		if Timer.getTime(load_tmr) > 4000 then
			Timer.destroy(load_tmr)
			load_tmr = nil
		else
			Font.print(ttf, 8, 470, "Game loaded successfully!", yellow)
		end
	end
	
	-- Main controls triggering
	pad = Controls.read()	
	if paused then
		if mode == nil then
			DrawPause()
		elseif mode == 1 then
			DrawSavegameMenu("SAVE GAME", true)
		elseif mode == 0 then
			DrawSavegameMenu("LOAD GAME", false)
		end
		if Controls.check(pad, SCE_CTRL_SQUARE) and not Controls.check(oldpad, SCE_CTRL_SQUARE) then
			if mode == 0 or (mode == 1 and save_idx > 1) then
				PlaySFX(step, NO_LOOP)
				Graphics.termBlend()
				Screen.flip()
				if askPlayer("Do you really want to delete the savegame?", a_st) then
					pad = SCE_CTRL_CROSS
					System.deleteFile(SAV_FOLDER .. "/" .. save_slots[save_idx - mode].name)
					table.remove(save_slots, save_idx - mode)
				end
			end
		elseif Controls.check(pad, SCE_CTRL_UP) and not Controls.check(oldpad, SCE_CTRL_UP) then
			PlaySFX(step, NO_LOOP)
			if mode == nil then
				p_idx = p_idx - 1
				if cur_voices == p_voices and p_idx == 3 and #save_slots == 0 then
					p_idx = p_idx - 1
				end
				if p_idx < 1 then
					p_idx = #cur_voices
				end
			else
				save_idx = save_idx - 1
				if save_idx < 1 then
					save_idx = #save_slots + mode -- mode = 1 for save, 0 for load
				end
			end
		elseif Controls.check(pad, SCE_CTRL_DOWN) and not Controls.check(oldpad, SCE_CTRL_DOWN) then
			PlaySFX(step, NO_LOOP)
			if mode == nil then
				p_idx = p_idx + 1
				if cur_voices == p_voices and p_idx == 3 and #save_slots == 0 then
					p_idx = p_idx + 1
				end
				if p_idx > #cur_voices then
					p_idx = 1
				end
			else
				save_idx = save_idx + 1
				if save_idx > #save_slots + mode then
					save_idx = 1 -- mode = 1 for save, 0 for load
				end
			end
		elseif Controls.check(pad, SCE_CTRL_CROSS) and not Controls.check(oldpad, SCE_CTRL_CROSS) then
			PlaySFX(step, NO_LOOP)
			
			if mode == nil then
			
				-- Paused Main Menu
				if cur_voices == p_voices then
			
					if p_idx == 1 then
						paused = false
						Timer.resume(tmr)
						Sound.resume(bgm)
						Sound.resume(bgm)
				
					elseif p_idx == 2 then
						mode = 1
						save_idx = 1
					
					elseif p_idx == 3 then
						mode = 0
						save_idx = 1
					
					elseif p_idx == 4 then
						cur_voices = p_voices_opt
						p_idx = 1
						
					elseif p_idx == 5 then
						skip_end = true
						break
					end
				
				-- Options Menu
				elseif cur_voices == p_voices_opt then
			
					if p_idx == 1 then
						cur_voices = p_voices_graphics
						p_idx = 1
					
					elseif p_idx == 2 then
						cur_voices = p_voices_audio
						p_idx = 1
					
					elseif p_idx == 3 then
						cur_voices = p_voices
						p_idx = 4
					end
				
				-- Graphics Menu
				elseif cur_voices == p_voices_graphics then
			
					if p_idx == 1 then
						changeTextureQuality()
						p_voices_graphics[1] = graphics_voices[1]
					
					elseif p_idx == 2 then
						changeShadingValue()
						p_voices_graphics[2] = graphics_voices[2]
					
					elseif p_idx == 3 then
						cur_voices = p_voices_opt
						p_idx = 1
					end
				
				-- Audio Menu
				elseif cur_voices == p_voices_audio then
			
					if p_idx == 1 then
						changeMusicValue()
						if isMusic then
							Sound.pause(bgm)
						end
						p_voices_audio[1] = audio_voices[1]
					
					elseif p_idx == 2 then
						changeSoundValue()
						p_voices_audio[2] = audio_voices[2]
					
					elseif p_idx == 3 then
						cur_voices = p_voices_opt
						p_idx = 2
					end
				
				end
				
			elseif mode == 1 then
				
				local new_save = false
				if save_idx == 1 then
					Keyboard.show("Insert save name", "save")
					Graphics.termBlend()
					Screen.flip()
					while true do
						Graphics.initBlend()
						Screen.clear()
						status = Keyboard.getState()
						if status ~= RUNNING then
							if status ~= CANCELED then
								save_name = Keyboard.getInput()
							else
								save_name = nil
							end
							Keyboard.clear()
							break
						end
						Graphics.termBlend()
						Screen.flip()
					end
					new_save = true
				else
					Graphics.termBlend()
					Screen.flip()
					if askPlayer("Do you really want to overwrite the savegame?", a_st) then
						save_name = save_slots[save_idx-1].name
					else
						save_name = nil
					end
				end
				if save_name ~= nil then
					tb = 0
					Graphics.termBlend()
					Screen.flip()
					while tb < 3 do
						Graphics.initBlend()
						if use_shading then
							Graphics.drawImage(0, 0, skybox)
						else
							Graphics.fillRect(0,960,0,544,ceil_c) -- Simulates skybox; currently faster then sky rendering
							Graphics.fillRect(0,960,273,544,floor_c) -- Simulates floor; currently faster then floor rendering
						end
						RayCast3D.renderScene(0,0)
						Graphics.drawPartialImage(284,440,anim,0,104 * a_st,376,104)
						Graphics.termBlend()
						Screen.flip()
						tb=tb+1
					end
					Graphics.initBlend()
					System.takeScreenshot(SAV_FOLDER.."/temp.bin",true)
					local sshot_hdl = System.openFile(SAV_FOLDER.."/temp.bin", FREAD)
					sshot_size = io.size(sshot_hdl)
					sshot_buf = System.readFile(sshot_hdl, sshot_size)
					System.closeFile(sshot_hdl)
					new_screen = Graphics.loadImage(SAV_FOLDER.."/temp.bin")
					System.deleteFile(SAV_FOLDER.."/temp.bin")
					local save_buffer = int2str(seed,4) .. int2str(tsizes[idx_sizes], 2) .. int2str(math.floor(Timer.getTime(tmr) + extra_playtime),4) .. int2str(#marked_cells, 2)
					local player = RayCast3D.getPlayer()
					save_buffer = save_buffer .. int2str(player.x,4) .. int2str(player.y,4) .. int2str(math.floor(rad2arc(math.rad(player.angle))), 4)
					save_buffer = save_buffer .. int2str(#marked_cells+scrolls,2)
					marked_cell_data = ""
					for i, cell in pairs(marked_cells) do
						marked_cell_data = marked_cell_data .. int2str(cell.x,4) .. int2str(cell.y,4)
					end
					save_buffer = save_buffer .. marked_cell_data
					save_buffer = save_buffer .. sshot_buf
					local checksum = int2str(crc32(save_buffer),4)
					save_buffer = checksum .. save_buffer
					local save_hdl = System.openFile(SAV_FOLDER.."/" .. save_name .. ".sav", FCREATE)
					System.writeFile(save_hdl, save_buffer, string.len(save_buffer))
					System.closeFile(save_hdl)
					save_tmr = Timer.new()
					mode = nil
					if new_save then
						table.insert(save_slots, {["size"] = tsizes[idx_sizes], ["name"] = save_name, ["playtime"] = math.floor(Timer.getTime(tmr) + extra_playtime), ["seed"] = seed, ["x"] = player.x, ["y"] = player.y, ["angle"] = math.floor(rad2arc(math.rad(player.angle))), ["scrolls"] = scrolls, ["marked"] = marked_cell_data, ["image"] = new_screen})
					else
						Graphics.freeImage(save_slots[save_idx-1].image)
						save_slots[save_idx-1] = {["size"] = tsizes[idx_sizes], ["name"] = save_name, ["playtime"] = Timer.getTime(tmr), ["seed"] = seed, ["x"] = player.x, ["y"] = player.y, ["angle"] = math.floor(rad2arc(math.rad(player.angle))), ["scrolls"] = scrolls, ["marked"] = marked_cell_data, ["image"] = new_screen}
					end
				end
				
			elseif mode == 0 then
				
				PrimmBuild(save_slots[save_idx].size, save_slots[save_idx].size, save_slots[save_idx].seed)
				RayCast3D.spawnPlayer(save_slots[save_idx].x, save_slots[save_idx].y, math.deg(arc2rad(save_slots[save_idx].angle)))
				extra_playtime = save_slots[save_idx].playtime
				Timer.reset(tmr)
				scrolls = save_slots[save_idx].scrolls
				marked_cells = {}
				local iter = 0
				while iter < string.len(save_slots[save_idx].marked) do
					local cell_x = str2int(string.sub(save_slots[save_idx].marked, iter+1, iter+4))
					local cell_y = str2int(string.sub(save_slots[save_idx].marked, iter+5, iter+8))
					local cell_idx = 1+cell_x+cell_y*wmap
					map[cell_idx] = M
					table.insert(marked_cells, {["x"] = cell_x,["y"] = cell_y})
					iter = iter + 8
				end
				mode = nil
				load_tmr = Timer.new()
				paused = false
				if isMusic then
					Sound.resume(bgm)
				end
				Timer.resume(tmr)
			
			end
			
		elseif Controls.check(pad, SCE_CTRL_CIRCLE) and not Controls.check(oldpad, SCE_CTRL_CIRCLE) then
			
			if mode == nil then
				PlaySFX(step, NO_LOOP)
				if cur_voices == p_voices_graphics then
					cur_voices = p_voices_opt
					p_idx = 1
				elseif cur_voices == p_voices_audio then
					cur_voices = p_voices_opt
					p_idx = 2
				elseif cur_voices == p_voices_opt then
					cur_voices = p_voices
					p_idx = 4
				else
					paused = false
					Timer.resume(tmr)
					Sound.resume(bgm)
				end
			elseif mode == 1 or mode == 0 then
				PlaySFX(step, NO_LOOP)
				mode = nil
			end
			
		end
	else
	
		-- FIXME: Add Gyroscope support
		if gyromode then
			
		end
		
		cmove = false
		cx, cy = Controls.readLeftAnalog()
		cx2 = Controls.readRightAnalog()
		if cx2 > 180 then
			RayCast3D.rotateCamera(RIGHT, cam_speed)
		elseif cx2 < 64 then
			RayCast3D.rotateCamera(LEFT, cam_speed)
		end
		if cx > 180 then
			RayCast3D.movePlayer(RIGHT, pl_speed)
			if isSFX then
				Sound.resume(walk)
			end
		elseif cx < 64 then
			RayCast3D.movePlayer(LEFT, pl_speed)
			if isSFX then
				Sound.resume(walk)
			end
		end
		if cy < 64 then
			RayCast3D.movePlayer(FORWARD, pl_speed)
			cmove = true
			if isSFX then
				Sound.resume(walk)
			end
		elseif cy > 180 then
			RayCast3D.movePlayer(BACK, pl_speed)
			cmove = true
			if isSFX then
				Sound.resume(walk)
			end
		end
		if Controls.check(pad,SCE_CTRL_LEFT) then
			RayCast3D.rotateCamera(LEFT, cam_speed)
		end
		if Controls.check(pad,SCE_CTRL_RIGHT) then
			RayCast3D.rotateCamera(RIGHT, cam_speed)
		end
		if Controls.check(pad,SCE_CTRL_UP) then
			RayCast3D.movePlayer(FORWARD, pl_speed)
			if isSFX then
				Sound.resume(walk)
			end
		elseif Controls.check(pad,SCE_CTRL_DOWN) then
			RayCast3D.movePlayer(BACK, pl_speed)
			if isSFX then
				Sound.resume(walk)
			end
		elseif not cmove then
			Sound.pause(walk)
		end
		
		-- Scroll Usage
		if Controls.check(pad, SCE_CTRL_CROSS) and not Controls.check(oldpad, SCE_CTRL_CROSS) and scrolls > 0 then
			pl = RayCast3D.getPlayer()
			cell = RayCast3D.shoot(pl.x, pl.y, pl.angle)
			c_idx = 1+cell.x+cell.y*wmap
			if map[c_idx] == W then
				scrolls = scrolls - 1
				table.insert(tcells, {["idx"] = c_idx,["st"] = 1})
				table.insert(marked_cells, {["x"] = cell.x,["y"] = cell.y})
				a_st = 1
				PlaySFX(spell, NO_LOOP)
			end
		end
		
		-- Player Animation
		if a_st > 0 then
			a_st = a_st + 1
			if a_st > 5 then
				a_st = 0
			end
		end
		
	end
	
	-- Tricky way to check if player won
	if Sound.isPlaying(walk) or not isSFX then
		player = RayCast3D.getPlayer()
		dx1 = bit32.rshift(player.x + 5, 6)
		dy1 = bit32.rshift(player.y + 5, 6)
		dx2 = bit32.rshift(player.x - 5, 6)
		dy2 = bit32.rshift(player.y - 5, 6)
		cx = bit32.rshift(player.x, 6)
		cy = bit32.rshift(player.y, 6)
		if dx1 - cx ~= 0 then
			cell = dx1 + cy * wmap + 1
			if map[cell] == 1 then
				Sound.pause(walk)
				break
			end
		end
		if dx2 - cx ~= 0 then
			cell = dx2 + cy * wmap + 1
			if map[cell] == 1 then
				Sound.pause(walk)
				break
			end
		end
		if dy1 - cy ~= 0 then
			cell = cx + dy1 * wmap + 1
			if map[cell] == 1 then
				Sound.pause(walk)
				break
			end
		end
		if dy2 - cy ~= 0 then
			cell = cx + dy2 * wmap + 1
			if map[cell] == 1 then
				Sound.pause(walk)
				break
			end
		end	
	end
	
	-- Drawing Seed
	tm = Timer.getTime(tmr)
	if tm < 5000 and not paused then
		Font.print(ttf, 5, 20, "Seed: " .. seed, Color.new(255,255,0))
	end
	
	-- FIXME: Add Blocks Fade Animation
	i = 1
	while i <= #tcells do	
		cell = tcells[i]
		map[cell.idx] = M
		table.remove(tcells, i)
	end
	
	-- Pause Menu Triggering
	if Controls.check(pad,SCE_CTRL_START) and not Controls.check(oldpad, SCE_CTRL_START) then
		p_idx = 1
		cur_voices = p_voices
		paused = not paused
		if paused then
			Sound.pause(walk)
			Sound.pause(bgm)
			Timer.pause(tmr)
		else
			if isMusic then
				Sound.resume(bgm)
			end
			Timer.resume(tmr)
			mode = nil
		end
	end
	
	Graphics.termBlend()
	Screen.flip()
	oldpad = pad
	
end
Graphics.termBlend()

-- Calculating time
Timer.pause(tmr)
raw = math.floor((Timer.getTime(tmr) + extra_playtime) / 1000)
h = math.floor(raw / 3600)
m = math.floor((raw - h * 3600) / 60)
s = raw % 60
if s < 10 then
	s = "0" .. s
end
if m < 10 then
	m = "0" .. m
end
if h < 10 then
	h = "0" .. h
end
res = h..":"..m..":"..s
 
while not skip_end do
	
	-- Rendering scene
	Graphics.initBlend()
	Graphics.fillRect(0,960,0,544,ceil_c) -- Simulates skybox; currently faster then sky rendering
	RayCast3D.renderScene(0,0)
		
	-- Player Animation
	Graphics.drawPartialImage(284,440,anim,0,0,376,104)
	
	-- Rendering Text
	Font.print(ttf,150, 150, "Your Time: "..res, white)
	Font.print(ttf,156, 180, "Seed: "..seed, white)
	Font.setPixelSizes(ttf,44)
	Font.print(ttf,100, 90, "YOU FOUND THE EXIT!", yellow)
	Font.setPixelSizes(ttf,24)
	
	Graphics.termBlend()
	Screen.flip()
	
	pad = Controls.read()
	
	-- Return Main Menu
	if Controls.check(pad, SCE_CTRL_START) or Controls.check(pad, SCE_CTRL_CROSS) then
		oldpad = pad
		break
	end
	
	oldpad = pad
	
end

Graphics.initBlend()
Sound.pause(bgm)
Sound.close(bgm)
Sound.close(spell)